
import java.io.*;
import java.util.*;


//--------------------------------------------------------------------------------------------

class Coords {
	
	double c_x;
	double c_y;

	public Coords (double x0, double y0) {
		c_x = x0;
		c_y = y0;
	}

	public String toString() {
		return "   "+c_x+"   "+c_y;
	}
}

//--------------------------------------------------------------------------------------------


class postalCodeParser {
	
	private final static String all_gb_pcs = "ab1.csv"; // hardcorded  FIXME

	public static void p(String str) {
		System.out.println(str);
	}

	static void help() {

		p("\nYou need to specify your file with postal_code_sectors needed to be processed.");
		p("Usage example: $ java postalCodeParser <my_file_with_postal_code_sectors>.");
		p("Script requires to have file 'postcodes.csv' located in the same directory.\n");
	}

//--------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------

	static void substr_pcs_with_coordinates(String one_gb_pcs_line) { //FIXME

		Scanner scan = new Scanner(one_gb_pcs_line);
		scan.useDelimiter(",");

		String full_code = "";
		double x0 = 0, y0 = 0;
		byte amount = 0;
		while (amount != 3 ) {
			if (scan.hasNext()) {
				full_code = scan.next();
			}
				amount += 1;
			if (scan.hasNextDouble()) {
				x0 = scan.nextDouble();
			}
				amount += 1;
			if (scan.hasNextDouble()) {
				y0 = scan.nextDouble();
			}
				amount += 1;
//FIXME			if (amount != 3) return;
		}
//DEBUG		p(full_code);
//DEBUG		p(x0);
//DEBUG		p(y0);

		scan.close();

//		put into hash-map values
		//FIXME
		Coords c_x_y = new Coords(x0,y0);
		pcs_map.put(full_code, c_x_y); 
	}

//--------------------------------------------------------------------------------------------

	public static void grep_by_outward_code (String providedFile) {	
		
		try (
			FileReader fr0 = new FileReader(all_gb_pcs);
			BufferedReader br0 = new BufferedReader(fr0);
			FileReader fr1 = new FileReader(providedFile);
			BufferedReader br1 = new BufferedReader(fr1)
/*			FileOutputStream fos = new FileOutputStream(substr_file, true);
			BufferedOutputStream bos = new BufferedOutputStream(fos);
			PrintWriter pw = new PrintWriter(bos) //	writing results to log file
//			FIXME need to use symbol not byte thread to write log*/
		) {
			String curline = "";
			String one_gb_pcs_line = "";

			do {
				curline = br1.readLine();
				if (curline != null) {
					do {
						one_gb_pcs_line = br0.readLine();
						if (one_gb_pcs_line != null &&
						    one_gb_pcs_line.startsWith(curline)) {
							p(one_gb_pcs_line); // DEBUG FIXME
							// call to function which will take PCS,X,Y
							// data for each matches request string
							substr_pcs_with_coordinates(one_gb_pcs_line);
						
						}	
					} while (one_gb_pcs_line != null);
				}
			} while (curline != null);

		} catch (FileNotFoundException exp) {
			System.out.println("no such file");
		} catch (IOException exp) {
			// do nothing
		}
	}

//--------------------------------------------------------------------------------------------

	static HashMap<String,Coords> pcs_map = new HashMap<String,Coords>();

	public static void main(String args[]) {
	
		if (args.length == 0) {
			help();
			return;
		}

	
		grep_by_outward_code(args[0]);

		Set <Map.Entry<String, Coords>> set = pcs_map.entrySet();

		for (Map.Entry<String, Coords> m_e : set) {
			System.out.printf("%10s",m_e.getKey());
			System.out.println(m_e.getValue());
		}

	}
}


